classdef CurveType_FP < handle
    %CURVETYPE_FP Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        branches
    end
    
    methods
    %     L = [ 'NS  ';'PD  '; 'LP  ';'BP  ' ];

    function obj = CurveType_FP()
       obj.branches = struct();
       %Branch(pttag, cttag , initfunc, periodmult, conditional , name)
       obj.branches.FP = { Branch('FP','FP', @init_FP_FP , 1 , false,'D') };
       obj.branches.PD = { Branch('PD','FP', @init_PD_FP , 2 , false,'SH') ,...
                           Branch('PD','FP', @init_FP_FP , 1 , false, 'D')};
                       
       obj.branches.BP = { Branch('BP','FP', @init_BP_FP , 1 , false,'SH'),...
                           Branch('BP','FP', @init_FP_FP , 1 , false, 'D')};
                       
       obj.branches.NS = { Branch('NS','FP', @init_FP_FP,  1 , false, 'D')};
       obj.branches.LP = { Branch('LP','FP', @init_FP_FP,  1 , false, 'D')};
    end
    
    
        function string = getName(obj)
            string = 'Fixed Point';
        end
        function string = getLabel(obj)
            string = 'FP';
        end
        
        %------------------------------------------------------
        function list  = allowedStarterOptions(obj)
            list = {'coordinates' , 'parameters' , 'ADnumber' , 'jacobian' , 'iterationN' , 'multipliers' ,'userfunction' , 'testfunctions' , 'amplitude' };
            
        end
        function [list,mindim] = getTestfunctions(obj)
            list =    {'NS' , 'PD' , 'LP' , 'BP'};
            mindim =  [ 2   ,   1    ,    1   ,   1 ];
        end
        
        function list = getNumericVarList(obj)
            list = {'coordinates','parameters','testfunctions','multipliers' ,'current_stepsize' , 'user_functions' , 'npoints'};
        end
        
        
        function list = getDependantGlobalVars(obj)
           list = {'cds','fpds'}; 
        end
        
        
        function nr = getReqNrFreeParams(obj)
           nr = 1; 
        end
        
        function [x0,v0] = performInit(obj, session, curve, x0 , par, systemhandle)
          
           initpointtag = session.getPointType().getLabel();
           
           n = session.starterdata.getSetting('iterationN');
           
           if (strcmp('BP' , initpointtag) ||  strcmp('PD' , initpointtag))
               if (strcmp('BP',initpointtag))
                  init = @init_BP_FP; 
               else
                  init = @init_PD_FP;
               end
               
               if (isempty(curve.startpoint))
                   %uh ow; een of andere throw nodig ofzo; FIXME
                   return
               else
                  [x0 , v0] = init(systemhandle , x0 , par , curve.startpoint , session.starterdata.getSetting('amplitude'),n); 
               end
               
           else
               [x0,v0] = init_FP_FP(systemhandle , x0 , par , session.starterdata.getActiveParams(),n );
           end
               
        end
        function bool = supportPoint(obj, pointtag)
            bool = ismember(pointtag, {'FP','PD' , 'BP'});
        end  
        function curvedef = getCurveDefinition(obj)
           curvedef = @fixedpointmap; 
        end
        
        function col = getDefaultColor(obj)
           col = 'black'; 
        end

        function list = getBranches(obj, pointtag)
           if (isfield(obj.branches,pointtag))
               list = obj.branches.(pointtag);
           else
               list = {};
           end
            
        end       
        function mat = getSingMatrix(obj)
           out = feval(obj.getCurveDefinition());
           mat = feval(out{9});
        end                
    end
end

