classdef TrajectPlot < handle
    properties
        plotconf
        plotter
    end
    
    
    methods
        function obj = TrajectPlot(session , coorddim)
            fig = figure();
            
            dim = 2 + (coorddim > 2);
            obj.plotconf = PlotConfiguration(session, fig, dim);
            
            mhandle = uimenu(fig, 'Label' , 'MatContM');
            uimenu(mhandle , 'Label' , 'Layout' , 'Callback' , @(o,e)  PlotConfigMainPanel(session.getWindowManager() , obj.plotconf));
        end
        
        function bool = startup(obj)
            if (obj.plotconf.checkLayoutValid())
                obj.plotter = obj.plotconf.makeReadyPlotObject();
                obj.plotter.plotops = {'LineStyle' , ':'};
                bool = true;
                
            else
               obj.plotter = [];
               bool = false;
            end            
        end
        
        function output(obj , varargin)
           obj.plotter.output(varargin{:}); 
        end
        function outputPoint(obj , varargin)
           obj.plotter.outputPoint(varargin{:}); 
           obj.plotconf.fitAxis();
        end
    end
    
end